Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/SimplificationMethod.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/SimplificationMethod.h	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/SimplificationMethod.h	(revision 1526)
@@ -9,106 +9,130 @@
 #include <GeoMeshSimplifier.h>
 
+using	namespace	Geometry;
+
 class SimplificationMethod
 {
-private:
-	Geometry::Mesh	*mGeoMesh;
-	void compute_pair_info(simplif::pair_info*);
-	simplif::Model M0;
-	simplif::array<simplif::vert_info> vinfo;
-	simplif::Heap *heap;
-	simplif::real proximity_limit;    // distance threshold squared
-	int initialVertCount;
-	int initialEdgeCount;
-	int initialFaceCount;
+	private:
 
-	inline simplif::vert_info& vertex_info(simplif::Vertex *v)
-	{
-		return vinfo(v->validID());
-	}
-	
-	simplif::real pair_mesh_penalty(simplif::Model& M,
-																simplif::Vertex *v1,
-																simplif::Vertex *v2,
-																simplif::Vec3& vnew);
-	
-	int predict_face(simplif::Face& F,
-									simplif::Vertex *v1,
-									simplif::Vertex *v2,
-									simplif::Vec3& vnew,
-									simplif::Vec3& f1,
-									simplif::Vec3& f2,
-									simplif::Vec3& f3);
-	
-	bool check_for_pair(simplif::Vertex *v0, simplif::Vertex *v1);
-	
-	simplif::pair_info *new_pair(simplif::Vertex *v0, simplif::Vertex *v1);
-	
-	void delete_pair(simplif::pair_info *pair);
-	
-	void do_contract(simplif::Model& m, simplif::pair_info *pair);
-	
-	bool decimate_quadric(simplif::Vertex *v, simplif::Mat4& Q);
-	
-	void decimate_contract(simplif::Model& m);
-	
-	simplif::real decimate_error(simplif::Vertex *v);
-	
-	simplif::real decimate_min_error();
-	
-	simplif::real decimate_max_error(simplif::Model& m);
-	
-	void decimate_init(simplif::Model& m, simplif::real limit);
-	
-	bool pair_is_valid(simplif::Vertex *u, simplif::Vertex *v);
-	
-	void simplifmethod_run(int,	Geometry::TIPOFUNC	upb=0);
-	
-	void simplifmethod_runv(int,	Geometry::TIPOFUNC	upb=0);
-	
-	void simplifmethod_init(void);
+		Geometry::Mesh	*mGeoMesh;
 
-	//	To map the mesh with de simplification method structure.
-	//	Submeshes which pertains each vertex.
-	std::map<int,std::vector<int> > submeshmap;
-	
-	//	Vertices of the VertexBuffer that point 
-	//	at this vertex of the simplification method.
-	std::map<int,std::vector<int> > vertexbuffermap; 
+		void compute_pair_info(simplif::pair_info*);
 
-	//	Simplification sequence of the simplification method.
-	std::vector<Geometry::MeshSimplificationSequence::Step> decim_data;
-	
-	std::string meshName;
-	
-	void WriteOBJ(void);
-	
-	unsigned int *first_index_submesh;
-	
-	//std::vector<simplif::pair_info *> pointers_to_remove;
+		simplif::Model M0;
 
-	int indexMeshLeaves;
-	
-public:
-	
-	const Geometry::Mesh *objmesh;
-	
-	//	Total number of triangles of all the submeshes.
-	int number_of_triangles;
-	
-	SimplificationMethod(const Geometry::Mesh *m);
-	
-	void geomesh2simplifModel(void);
-	
-	Geometry::MeshSimplificationSequence *Decimate(	float lod,
-																									int simpliftype,
-																									Geometry::TIPOFUNC	upb=0);
-	
-	void setMeshLeaves(int meshLeaves);
+		simplif::array<simplif::vert_info> vinfo;
 
-	///	Gets mesh simplified.
-	Geometry::Mesh	*	GetMesh();
-	
-	///Destructor
-	~SimplificationMethod();
+		simplif::Heap *heap;
+		simplif::real proximity_limit;    // distance threshold squared
+
+		int initialVertCount;
+		int initialEdgeCount;
+		int initialFaceCount;
+
+		//	Simplification sequence.
+		MeshSimplificationSequence	*msimpseq;
+
+		//	Stores the simplification step.
+		MeshSimplificationSequence::Step simplifstep;
+
+		inline simplif::vert_info& vertex_info(simplif::Vertex *v)
+		{
+			return vinfo(v->validID());
+		}
+
+		simplif::real pair_mesh_penalty(simplif::Model& M,
+				simplif::Vertex *v1,
+				simplif::Vertex *v2,
+				simplif::Vec3& vnew);
+
+		int predict_face(simplif::Face& F,
+				simplif::Vertex *v1,
+				simplif::Vertex *v2,
+				simplif::Vec3& vnew,
+				simplif::Vec3& f1,
+				simplif::Vec3& f2,
+				simplif::Vec3& f3);
+
+		bool check_for_pair(simplif::Vertex *v0, simplif::Vertex *v1);
+
+		simplif::pair_info *new_pair(simplif::Vertex *v0, simplif::Vertex *v1);
+
+		void delete_pair(simplif::pair_info *pair);
+
+		void do_contract(simplif::Model& m, simplif::pair_info *pair);
+
+		bool decimate_quadric(simplif::Vertex *v, simplif::Mat4& Q);
+
+		void decimate_contract(simplif::Model& m);
+
+		simplif::real decimate_error(simplif::Vertex *v);
+
+		simplif::real decimate_min_error();
+
+		simplif::real decimate_max_error(simplif::Model& m);
+
+		void decimate_init(simplif::Model& m, simplif::real limit);
+
+		bool pair_is_valid(simplif::Vertex *u, simplif::Vertex *v);
+
+		void simplifmethod_run(int,	Geometry::TIPOFUNC	upb=0);
+
+		void simplifmethod_runv(int,	Geometry::TIPOFUNC	upb=0);
+
+		void simplifmethod_init(void);
+
+		//	To map the mesh with de simplification method structure.
+		//	Submeshes which pertains each vertex.
+		std::map< int,	std::vector<int> > submeshmap;
+
+		//	Vertices of the VertexBuffer that point
+		//	at this vertex of the simplification method.
+		std::map< int,	std::vector<int> > vertexbuffermap;
+
+		//	Simplification sequence of the simplification method.
+		std::vector<Geometry::MeshSimplificationSequence::Step> decim_data;
+
+		std::string meshName;
+
+		unsigned int *first_index_submesh;
+
+		//std::vector<simplif::pair_info *> pointers_to_remove;
+
+		int indexMeshLeaves;
+
+		//	Contract lonely vertices that have same coords than the contracted one.
+		void	contractLonelyVertices(	simplif::Model	&m,
+																	simplif::Vertex	*v0,
+																	simplif::Vertex *v1,
+																	simplif::Vec3		candidate);
+
+		//	Remove twin edges.
+		void	removeTwinEdges(simplif::Model	&m,
+													simplif::Vertex	*v0,
+													simplif::Vertex	*v1,
+													simplif::Vec3		candidate);
+
+	public:
+
+		const Geometry::Mesh *objmesh;
+
+		//	Total number of triangles of all the submeshes.
+		int number_of_triangles;
+
+		SimplificationMethod(const Geometry::Mesh *m);
+
+		void	generateSimplifModel(void);
+
+		Geometry::MeshSimplificationSequence *Decimate(	float lod,
+				int simpliftype,
+				Geometry::TIPOFUNC	upb=0);
+
+		void setMeshLeaves(int meshLeaves);
+
+		///	Gets mesh simplified.
+		Geometry::Mesh	*	GetMesh();
+
+		///	Destructor.
+		~SimplificationMethod();
 };
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjModel.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjModel.h	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjModel.h	(revision 1526)
@@ -22,113 +22,128 @@
 	class Model : public SMF_Model
 	{
-	protected:
-		vert_buffer vertices;
-		edge_buffer edges;
-		face_buffer faces;
-		vec3_buffer normals; // SUS
-		vec2_buffer texcoords;
+		protected:
+			
+			vert_buffer vertices;
+			edge_buffer edges;
+			face_buffer faces;
+			vec3_buffer normals; // SUS
+			vec2_buffer texcoords;
 
-	private:
+		private:
 
-		void maybeFixFace(Face *);
+			void maybeFixFace(Face *);
 
-	public:
-		Model() {
-			validVertCount = 0;
-			validEdgeCount = 0;
-			validFaceCount = 0;
-		}
+		public:
+			
+			Model()
+			{
+				validVertCount = 0;
+				validEdgeCount = 0;
+				validFaceCount = 0;
+			}
 
-		~Model(){
-			for (int i=0; i<vertices.length(); i++)
-				delete vertices[i];
-			for (int i=0; i<edges.length(); i++)
-				delete edges[i];
-			for (int i=0; i<faces.length(); i++)
-				delete faces[i];
-		}
+			~Model()
+			{
+				for (int i=0; i<vertices.length(); i++)
+				{
+					delete vertices[i];
+				}
 
-		Bounds bounds;
+				for (int i=0; i<edges.length(); i++)
+				{
+					delete edges[i];
+				}
 
-		int validVertCount;
-		int validEdgeCount;
-		int validFaceCount;
+				for (int i=0; i<faces.length(); i++)
+				{
+					delete faces[i];
+				}
+			}
 
-		//
-		// Basic model accessor functions
-		//
-		simplif::Vertex *vertex(int i) { return vertices(i); }
-		simplif::Vec3 & normal(int i){ return normals(i); }
-		simplif::Vec2 & texcoord(int i){ return texcoords(i); }
-		simplif::Edge *edge(int i) { return edges(i); }
-		simplif::Face *face(int i) { return faces(i); }
+			Bounds bounds;
 
-		int vertCount() { return vertices.length(); }
-		int normCount() { return normals.length();  }
-		int texcoordCount() { return texcoords.length();  }
-		int edgeCount() { return edges.length();    }
-		int faceCount() { return faces.length();    }
+			int validVertCount;
+			int validEdgeCount;
+			int validFaceCount;
 
-		vert_buffer& allVertices() { return vertices; }
-		edge_buffer& allEdges()    { return edges;    }
-		face_buffer& allFaces()    { return faces;    }
+			//
+			// Basic model accessor functions
+			//
+			simplif::Vertex *vertex(int i) { return vertices(i); }
+			simplif::Vec3 & normal(int i){ return normals(i); }
+			simplif::Vec2 & texcoord(int i){ return texcoords(i); }
+			simplif::Edge *edge(int i) { return edges(i); }
+			simplif::Face *face(int i) { return faces(i); }
 
-		//
-		// Simplification primitives
-		//
-		Vertex   *newVertex(real x=0.0, real y=0.0, real z=0.0);
-		Edge     *newEdge(Vertex *,Vertex *);
-		Face *newFace(Vertex *, Vertex *, Vertex *);
+			int vertCount() { return vertices.length(); }
+			int normCount() { return normals.length();  }
+			int texcoordCount() { return texcoords.length();  }
+			int edgeCount() { return edges.length();    }
+			int faceCount() { return faces.length();    }
 
-		void killVertex(Vertex *);
-		void killEdge(Edge *);
-		void killFace(Face *);
+			vert_buffer& allVertices() { return vertices; }
+			edge_buffer& allEdges()    { return edges;    }
+			face_buffer& allFaces()    { return faces;    }
 
-		void reshapeVertex(Vertex *, real, real, real);
-		void remapVertex(Vertex *from, Vertex *to);
+			//
+			// Simplification primitives
+			//
+			Vertex   *newVertex(real x=0.0, real y=0.0, real z=0.0);
+			Edge     *newEdge(Vertex *,Vertex *);
+			Face *newFace(Vertex *, Vertex *, Vertex *);
 
-		void contract(Vertex *v1, Vertex *v2, const Vec3& to,
-			  face_buffer& changed);
+			void killVertex(Vertex *);
+			void killEdge(Edge *);
+			void killFace(Face *);
 
-		void contract(Vertex *v1, 
-			  const vert_buffer& others,
-			  const Vec3& to,
-			  face_buffer& changed);
+			void reshapeVertex(Vertex *, real, real, real);
+			void remapVertex(Vertex *from, Vertex *to);
 
+			void contract(Vertex *v1, Vertex *v2, const Vec3& to,
+					face_buffer& changed);
 
-		//
-		// Simplification convenience procedures
-		//
-		void removeDegeneracy(face_buffer& changed);
-		void contractionRegion(Vertex *v1, Vertex *v2, face_buffer& changed);
-		void contractionRegion(Vertex *v1,
-				   const vert_buffer& vertices,
-				   face_buffer& changed);
+			void contract(Vertex *v1, 
+					const vert_buffer& others,
+					const Vec3& to,
+					face_buffer& changed);
 
-		//
-		// SMF reader functions
-		//
-		int in_Vertex(const Vec3&);
-		int in_Normal(const Vec3&);
-		int in_TexCoord(const Vec2&);
-		int in_Face(int v1, int v2, int v3, int n1, int n2, int n3, int t1, int t2, int t3);
-		int miin_Face(int v1, int v2, int v3);
+			//
+			// Simplification convenience procedures
+			//
+			void removeDegeneracy(face_buffer& changed);
+			void contractionRegion(Vertex *v1, Vertex *v2, face_buffer& changed);
+			void contractionRegion(Vertex *v1,
+					const vert_buffer& vertices,
+					face_buffer& changed);
 
-/*	#ifdef SUPPORT_VCOLOR
-		int in_VColor(const Vec3&);
-	#endif
-	#ifdef SUPPORT_FCOLOR
-		int in_FColor(const Vec3&);
-	#endif
+			//
+			// SMF reader functions
+			//
+			int in_Vertex(const Vec3&);
+			int in_Normal(const Vec3&);
+			int in_TexCoord(const Vec2&);
+
+			int in_Face(int v1, int v2, int v3, 
+									int n1, int n2, int n3,
+									int t1, int t2, int t3);
+
+			int miin_Face(int v1, int v2, int v3);
+
+			/*	#ifdef SUPPORT_VCOLOR
+					int in_VColor(const Vec3&);
+#endif
+#ifdef SUPPORT_FCOLOR
+int in_FColor(const Vec3&);
+#endif
 */
-		//
-		// Some random functions that are mostly temporary
-		//
+			//
+			// Some random functions that are mostly temporary
+			//
 
-		Vec3 synthesizeNormal(Vertex *);
+			Vec3 synthesizeNormal(Vertex *);
 	};
 }
 
-
 // NAUTILUS_ADJMODEL_INCLUDED
 #endif
+
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjPrims.cxx
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjPrims.cxx	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjPrims.cxx	(revision 1526)
@@ -18,25 +18,25 @@
 {
 #ifdef SAFETY
-    assert( edge_uses.length() == 0 );
-#endif
-    markInvalid();
-    edge_uses.reset();
+	assert( edge_uses.length() == 0 );
+#endif
+	markInvalid();
+	edge_uses.reset();
 }
 
 void Vertex::linkEdge(Edge *e)
 {
-    edge_uses.add(e);
+	edge_uses.add(e);
 }
 
 void Vertex::unlinkEdge(Edge *e)
 {
-    int index = edge_uses.find(e);
-
-#ifdef SAFETY
-    assert( index >= 0 );
-#endif
-    edge_uses.remove(index);
-    if( edge_uses.length() <= 0 )
-	kill();
+	int index = edge_uses.find(e);
+
+#ifdef SAFETY
+	assert( index >= 0 );
+#endif
+	edge_uses.remove(index);
+	if( edge_uses.length() <= 0 )
+		kill();
 }
 
@@ -45,7 +45,7 @@
 void Vertex::remapTo(Vertex *v)
 {
-    if( v != this )
-    {
-		for(int i=0; i<edge_uses.length(); i++)
+	if ( v != this )
+	{
+		for (int i=0; i<edge_uses.length(); i++)
 		{
 			assert( edge_uses(i)->org() == this );
@@ -54,37 +54,36 @@
 
 		kill();
-    }
-}
-
+	}
+}
 
 Edge::Edge(Vertex *a, Vertex *b)
 {
-    v1 = a;
-    v1->linkEdge(this);
-
-    face_uses = new buffer<Face *>(2);
-
-    twin = new Edge(this, b);
+	v1 = a;
+	v1->linkEdge(this);
+
+	face_uses = new buffer<Face *>(2);
+
+	twin = new Edge(this, b);
 }
 
 Edge::Edge(Edge *sibling, Vertex *org)
 {
-    v1 = org;
-    v1->linkEdge(this);
-
-    face_uses = sibling->face_uses;
-    twin = sibling;
+	v1 = org;
+	v1->linkEdge(this);
+
+	face_uses = sibling->face_uses;
+	twin = sibling;
 }
 
 Edge::~Edge()
 {
-    if( twin )
-    {
-	face_uses->f_r_e_e();
-	delete face_uses;
-
-	twin->twin = NULL;
-	delete twin;
-    }
+	if ( twin )
+	{
+		face_uses->f_r_e_e();
+		delete face_uses;
+
+		twin->twin = NULL;
+		delete twin;
+	}
 }
 
@@ -92,87 +91,86 @@
 {
 #ifdef SAFETY
-    assert( face_uses->length() == 0 );
-#endif
-    if( isValid() )
-    {
-	org()->unlinkEdge(this);
-	dest()->unlinkEdge(sym());
-	markInvalid();
-	twin->markInvalid();
-	face_uses->reset();
-    }
+	assert( face_uses->length() == 0 );
+#endif
+	if ( isValid() )
+	{
+		org()->unlinkEdge(this);
+		dest()->unlinkEdge(sym());
+		markInvalid();
+		twin->markInvalid();
+		face_uses->reset();
+	}
 }
 
 void Edge::linkFace(Face *face)
 {
-    face_uses->add(face);
+	face_uses->add(face);
 }
 
 void Edge::unlinkFace(Face *face)
 {
-    int index = face_uses->find(face);
-
-#ifdef SAFETY
-    assert( index>=0 );
-#endif
-    face_uses->remove(index);
-    if( face_uses->length() == 0 )
-	kill();
+	int index = face_uses->find(face);
+
+#ifdef SAFETY
+	assert( index>=0 );
+#endif
+	face_uses->remove(index);
+	if( face_uses->length() == 0 )
+		kill();
 }
 
 void Edge::remapTo(Edge *e)
 {
-    if( e != this )
-    {
-	for(int i=0; i<face_uses->length(); i++)
-	{
-	    (*face_uses)(i)->remapEdge(this, e);
-	}
-    
-	// Disconnect from all faces and vertices
-	kill();
-    }
+	if ( e != this )
+	{
+		for (int i=0; i<face_uses->length(); i++)
+		{
+			(*face_uses)(i)->remapEdge(this, e);
+		}
+
+		// Disconnect from all faces and vertices
+		kill();
+	}
 }
 
 void Edge::remapEndpoint(Vertex *from, Vertex *to)
 {
-    if( org()==from )
-    {
+	if ( org() == from )
+	{
 		v1 = to;
 		to->linkEdge(this);
-    }
-    else if( dest()==from )
-    {
+	}
+	else if ( dest() == from )
+	{
 		twin->v1 = to;
 		to->linkEdge(twin);
-    }
-    else
-    {
+	}
+	else
+	{
 		std::cerr << "WARNING remapEndpoint: Illegal endpoint." << std::endl;
-    }
-
-    //
-    // The cached Plane equations for the faces attached to us may
-    // no longer be valid (in general, chances are pretty slim that they're OK)
-    for(int i=0; i<face_uses->length(); i++)
-    {
+	}
+
+	//
+	// The cached Plane equations for the faces attached to us may
+	// no longer be valid (in general, chances are pretty slim that they're OK)
+	for (int i	=	0; i < face_uses->length(); i++)
+	{
 		face_uses->ref(i)->invalidatePlane();
-    }
-}
-
+	}
+}
 
 Face::Face(Edge *e0, Edge *e1, Edge *e2)
     : Face3(*e0->org(), *e1->org(), *e2->org())
 {
-    edges[0] = e0;
-    edges[1] = e1;
-    edges[2] = e2;
-
-    edges[0]->linkFace(this);
-    edges[1]->linkFace(this);
-    edges[2]->linkFace(this);
+	edges[0] = e0;
+	edges[1] = e1;
+	edges[2] = e2;
+
+	edges[0]->linkFace(this);
+	edges[1]->linkFace(this);
+	edges[2]->linkFace(this);
 
 #ifdef SUPPORT_FCOLOR
-    props = NULL;
+	props = NULL;
 #endif
 }
@@ -180,88 +178,91 @@
 void Face::kill()
 {
-    if( isValid() )
-    {
-	if( edge(0)->isValid() )
-	    edge(0)->unlinkFace(this);
-
-	if( edge(1)->isValid() )
-	    edge(1)->unlinkFace(this);
-
-	if( edge(2)->isValid() )
-	    edge(2)->unlinkFace(this);
-
-	markInvalid();
-    }
+	if( isValid() )
+	{
+		if( edge(0)->isValid() )
+			edge(0)->unlinkFace(this);
+
+		if( edge(1)->isValid() )
+			edge(1)->unlinkFace(this);
+
+		if( edge(2)->isValid() )
+			edge(2)->unlinkFace(this);
+
+		markInvalid();
+	}
 }
 
 void Face::remapEdge(Edge *from, Edge *to)
 {
-    for(int i=0; i<3; i++)
-    {
-	if( edges[i] == from )
-	{
-	    edges[i] = to;
-	    to->linkFace(this);
-	}
-	else if( edges[i] == from->sym() )
-	{
-	    edges[i] = to->sym();
-	    to->sym()->linkFace(this);
-	}
-    }
-
-    invalidatePlane();
-}
-
+	for (int i=0; i<3; i++)
+	{
+		if ( edges[i] == from )
+		{
+			edges[i] = to;
+			to->linkFace(this);
+		}
+		else if ( edges[i] == from->sym() )
+		{
+			edges[i] = to->sym();
+			to->sym()->linkFace(this);
+		}
+	}
+
+	invalidatePlane();
+}
 
 void simplif::untagFaceLoop(Vertex *v)
 {
-    edge_buffer& edges = v->edgeUses();
-
-    for(int j=0; j<edges.length(); j++)
-    {	    
-	face_buffer& faces = edges(j)->faceUses();
-	for(int k=0; k<faces.length(); k++)
-	    faces(k)->untag();
-    }
+	edge_buffer& edges = v->edgeUses();
+
+	for (int j	=	0; j < edges.length(); j++)
+	{	    
+		face_buffer& faces = edges(j)->faceUses();
+
+		for (int k	=	0; k < faces.length(); k++)
+		{
+			faces(k)->untag();
+		}
+	}
 }
 
 void simplif::collectFaceLoop(Vertex *v, face_buffer& loop)
 {
-    edge_buffer& edges = v->edgeUses();
-
-    for(int j=0; j<edges.length(); j++)
-    {	    
-	face_buffer& faces = edges(j)->faceUses();
-	for(int k=0; k<faces.length(); k++)
-	    if( !faces(k)->isTagged() )
-	    {
-		loop.add(faces(k));
-		faces(k)->tag();
-	    }
-    }
+	edge_buffer& edges = v->edgeUses();
+
+	for(int j=0; j<edges.length(); j++)
+	{	    
+		face_buffer& faces = edges(j)->faceUses();
+		for(int k=0; k<faces.length(); k++)
+			if( !faces(k)->isTagged() )
+			{
+				loop.add(faces(k));
+				faces(k)->tag();
+			}
+	}
 }
 
 int simplif::classifyEdge(Edge *e)
 {
-    int cls = e->faceUses().length();
-
-    if( cls>3 ) cls=3;
-
-    return cls;
+	int cls = e->faceUses().length();
+
+	if( cls>3 ) cls=3;
+
+	return cls;
 }
 
 int simplif::classifyVertex(Vertex *v)
 {
-    int border_count = 0;
-    const edge_buffer& edges = v->edgeUses();
-
-    for(int i=0; i<edges.length(); i++)
-	if( classifyEdge(edges(i)) == 1 )
-	    border_count++;
-
-    if( border_count == edges.length() )
-	return VERTEX_BORDER_ONLY;
-    else 
-	return (border_count > 0);
-}
+	int border_count = 0;
+	const edge_buffer& edges = v->edgeUses();
+
+	for(int i=0; i<edges.length(); i++)
+		if( classifyEdge(edges(i)) == 1 )
+			border_count++;
+
+	if( border_count == edges.length() )
+		return VERTEX_BORDER_ONLY;
+	else 
+		return (border_count > 0);
+}
+
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/avars.cxx
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/avars.cxx	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/avars.cxx	(revision 1526)
@@ -19,5 +19,5 @@
 bool simplif::will_preserve_mesh_quality = true;
 bool simplif::will_constrain_boundaries = true;
-simplif::real simplif::boundary_constraint_weight = 1.0;
+simplif::real simplif::boundary_constraint_weight = 10.0;
 
 bool simplif::will_weight_by_area = false;
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshSimpSequence.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshSimpSequence.cpp	(revision 1009)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshSimpSequence.cpp	(revision 1526)
@@ -4,94 +4,135 @@
 using namespace std;
 
-MeshSimplificationSequence::MeshSimplificationSequence() 
+//---------------------------------------------------------------------------
+//	Constructor.
+//---------------------------------------------------------------------------
+MeshSimplificationSequence::MeshSimplificationSequence()
 {
-	meshName="";
+	meshName	=	"";
 }
 
-MeshSimplificationSequence::~MeshSimplificationSequence() 
+MeshSimplificationSequence::~MeshSimplificationSequence()
 {
 }
 
-void MeshSimplificationSequence::Load(Serializer &s) 
+//---------------------------------------------------------------------------
+//	Loads mesh simplification sequence.
+//---------------------------------------------------------------------------
+void MeshSimplificationSequence::Load(Serializer &s)
 {
-	//Loads a simplification sequence from a file
-	char buffer[256];
-	unsigned int modVertex;
-	char name[256];
+	//	Loads a simplification sequence from a file.
+	char 					buffer[256];
+	unsigned int	modVertex;
+	char					name[256];
 
+	//	Read mesh name.
 	if (s.ReadData(buffer,256) != NULL)
 	{
 		sscanf(buffer,"%s",&name);
-		meshName=new char[strlen(name)];
+
+		meshName	=	new char[strlen(name)];
+
 		strcpy(meshName,name);
 	}
 
+	//	Read steps data.
 	while (s.ReadData(buffer,256) != NULL)
 	{
 		Geometry::MeshSimplificationSequence::Step simplifstep;
-		//new step
-		sscanf(buffer,"%u %u %u %u %u %f %f %f &",&simplifstep.mV1,&simplifstep.mV0, &simplifstep.mT0,&simplifstep.mT1, &simplifstep.obligatorio,&simplifstep.x, &simplifstep.y, &simplifstep.z);
-		//sscanf(buffer,"%u %u %u %u %u &",&simplifstep.mV1,&simplifstep.mV0, &simplifstep.mT0,&simplifstep.mT1, &simplifstep.obligatorio);
-		//sscanf(buffer + 3,"%u %u %f %f %f %u %u &",&simplifstep.mV0,&simplifstep.mV1,&simplifstep.x, &simplifstep.y, &simplifstep.z, &simplifstep.mT0,&simplifstep.mT1);
-		//sscanf(buffer,"%u %u %u %u %u &",&simplifstep.mV0,&simplifstep.mV1,&simplifstep.mT0,&simplifstep.mT1, &simplifstep.obligatorio);
 
-		buffer[strlen(buffer)-1]='\0';
+		//	New step.
+		sscanf(	buffer,
+						"%u %u %u %u %u %f %f %f &",
+						&simplifstep.mV1,
+						&simplifstep.mV0,
+						&simplifstep.mT0,
+						&simplifstep.mT1,
+						&simplifstep.obligatory,
+						&simplifstep.x,
+						&simplifstep.y,
+						&simplifstep.z);
 
-		//if(!simplifstep.obligatorio)
-		//{
+		buffer[strlen(buffer)-1]	=	'\0';
+
 		char *ptr1;
-		ptr1=strtok(buffer,"&");
-		ptr1=strtok(NULL,"&");
 
-		if (ptr1!=NULL)
+		ptr1	=	strtok(buffer,"&");
+		ptr1	=	strtok(NULL,"&");
+
+		if (ptr1 != NULL)
 		{
 			char *ptr;
-			ptr=strtok(ptr1," ");
+
+			ptr	=	strtok(ptr1," ");
 			
-			while(ptr != NULL )
+			while (ptr != NULL )
 			{
-				modVertex = (unsigned int)atoi(ptr);
+				modVertex	=	(unsigned int)atoi(ptr);
+
 				simplifstep.mModfaces.push_back(modVertex);
-				ptr=strtok(NULL," ");
+
+				ptr	=	strtok(NULL," ");
 			}
 		}
+
 		mSteps.push_back(simplifstep);
-		//}
-
 	}
-
 }
 
+//---------------------------------------------------------------------------
+//	Saves simplification sequence.
+//---------------------------------------------------------------------------
 void MeshSimplificationSequence::Save(Serializer &s)
 {
-	//Stores the simplification sequence in a file
+	//	Stores the simplification sequence in a file.
 	char simp[256];
 
-	//Name of the mesh
+	//	Name of the mesh.
 	sprintf(simp,"%s\n",meshName);
 	s.WriteData(simp,sizeof(char),strlen(simp));
 
-	for(unsigned int i=0; i<mSteps.size(); i++)
+	//	For each step.
+	for (unsigned int i	=	0; i < mSteps.size(); i++)
 	{
 		Geometry::MeshSimplificationSequence::Step paso = mSteps.operator [](i);
-		//sprintf(simp,"%u %u %u %u %u &", paso.mV0, paso.mV1, paso.mT0, paso.mT1,paso.obligatorio);
-		sprintf(simp,"%u %u %u %u %u %f &", paso.mV0, paso.mV1, paso.mT0, paso.mT1,paso.obligatorio,paso.x);
+		
+		sprintf(simp,
+						"%u %u %u %u %u %f &",
+						paso.mV0,
+						paso.mV1,
+						paso.mT0,
+						paso.mT1,
+						paso.obligatory,
+						paso.x);
+
+		//	Write step.
 		s.WriteData(simp,sizeof(char),strlen(simp));
-		for (unsigned int j=0; j<paso.mModfaces.size(); j++)
+		
+		//	Triangles modified.
+		for (unsigned int j	=	0; j < paso.mModfaces.size(); j++)
 		{
 			sprintf(simp," %u",paso.mModfaces.operator [](j));
 			s.WriteData(simp,sizeof(char),strlen(simp));
 		}
+		
+		//	New line.
 		s.WriteData("\n",sizeof(char),1);
 	}
 }
 
-void MeshSimplificationSequence::putMeshName(char *name) 
+//---------------------------------------------------------------------------
+//	Puts mesh name.
+//---------------------------------------------------------------------------
+void MeshSimplificationSequence::putMeshName(char *name)
 {
-	meshName=name;
+	meshName	=	name;
 }
 
-char *MeshSimplificationSequence::getMeshName(void) 
+//---------------------------------------------------------------------------
+//	Gets mesh name.
+//---------------------------------------------------------------------------
+char *MeshSimplificationSequence::getMeshName(void)
 {
 	return meshName;
 }
+
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshSimplifier.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshSimplifier.cpp	(revision 1070)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoMeshSimplifier.cpp	(revision 1526)
@@ -413,5 +413,5 @@
 		current_step.z	=	VMI::mVMISteps[i].z;
 
-		current_step.obligatorio	=	VMI::mVMISteps[i].obligatory;
+		current_step.obligatory	=	VMI::mVMISteps[i].obligatory;
 
 		//	For each face modificated.
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodTreeLibrary.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodTreeLibrary.cpp	(revision 1136)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoLodTreeLibrary.cpp	(revision 1526)
@@ -7,12 +7,9 @@
 Geometry::LodTreeLibrary::LodTreeLibrary(const LodStripsLibraryData *lodstripsdata,
 										 const TreeSimplificationSequence *simpseq,
-										 Geometry::Mesh *treeGeoMesh/*,
-										 uint32 leafSubMeshID,
-							   CREATEVERTEXDATAFUNC vdfun,
-							   CREATEINDEXDATAFUNC idfun,
-							   CREATEMULTIINDEXDATAFUNC midfun*/)
+										 Geometry::Mesh *treeGeoMesh,
+										 Geometry::IndexData *userindexdata)
 {
 	// Cargar el tronco
-	trunk = new LodStripsLibrary(lodstripsdata,treeGeoMesh);
+	trunk = new LodStripsLibrary(lodstripsdata,treeGeoMesh,userindexdata);
 
 	// select the first triangle-list submesh as leaves submesh
@@ -28,7 +25,10 @@
 	}
 
+	delete_indexdata=false;
+	dataRetrievalInterface=userindexdata;
+
 	// Cargar la copa del árbol
 	Geometry::SubMesh * leafsSubMesh = &(treeGeoMesh->mSubMesh[mLeavesSubMesh]);
-	foliage = new Foliage(leafsSubMesh,simpseq);
+	foliage = new Foliage(mLeavesSubMesh,leafsSubMesh,simpseq);
 	GoToFoliageLod(1.0f);
 }
@@ -56,7 +56,5 @@
 	if (trunk) delete trunk;
 	if (foliage) delete foliage;
-/*	if (trunk_all_indices) delete trunk_all_indices;
-	if (indices_offsets) delete[] indices_offsets;
-//	if (current_foliage_indices) delete[] current_foliage_indices;*/
+	if (delete_indexdata) delete dataRetrievalInterface;
 }
 /*
@@ -101,19 +99,10 @@
 void LodTreeLibrary::GoToFoliageLod(float newlod)
 {
-	uint32 targetLeaves = (uint32)
-												(
-													(1.0f - newlod)
-													*
-													foliage->minLeaves
+	uint32 targetLeaves = (uint32)	(	(1.0f - newlod) * foliage->minLeaves
 													+
-													newlod
-													*
-													foliage->leafCount
-												);
+										newlod * foliage->leafCount 	);
 
 	foliage->CalculateLOD(targetLeaves);
 
-	foliage->indexdata->Begin();
-	foliage->vertexdata->Begin();
 	int i = foliage->begin;
 	int auxnumleaves = 0;
@@ -124,6 +113,8 @@
 	}
 
-	assert(auxnumleaves*6<=int(foliage->indexdata->GetNumMaxIndices()));
-	foliage->indexdata->SetNumValidIndices(auxnumleaves*6);
+//	foliage->indexdata->Begin(GetLeavesSubMesh(),auxnumleaves*6);
+	dataRetrievalInterface->Begin(GetLeavesSubMesh(),auxnumleaves*6);
+//	foliage->vertexdata->Begin();
+
 	i = foliage->begin;
 	int index=0;
@@ -136,21 +127,22 @@
 		v3 = foliage->Leaves[i].vertsLeaf[3];
 
-		foliage->indexdata->SetIndex(index+0,v0);
-		foliage->indexdata->SetIndex(index+1,v1);
-		foliage->indexdata->SetIndex(index+2,v2);
-		foliage->indexdata->SetIndex(index+3,v2);
-		foliage->indexdata->SetIndex(index+4,v1);
-		foliage->indexdata->SetIndex(index+5,v3);
-
-		foliage->vertexdata->SetVertexTexCoord(v0,0,0);
+		dataRetrievalInterface->SetIndex(index+0,v0);
+		dataRetrievalInterface->SetIndex(index+1,v1);
+		dataRetrievalInterface->SetIndex(index+2,v2);
+		dataRetrievalInterface->SetIndex(index+3,v2);
+		dataRetrievalInterface->SetIndex(index+4,v1);
+		dataRetrievalInterface->SetIndex(index+5,v3);
+
+/*		foliage->vertexdata->SetVertexTexCoord(v0,0,0);
 		foliage->vertexdata->SetVertexTexCoord(v1,0,1);
 		foliage->vertexdata->SetVertexTexCoord(v2,1,0);
-		foliage->vertexdata->SetVertexTexCoord(v3,1,1); 
+		foliage->vertexdata->SetVertexTexCoord(v3,1,1); */
 
 		index+=6;
 		i=foliage->Acth[i].next;
 	}
-	foliage->indexdata->End();
-	foliage->vertexdata->End();
+	dataRetrievalInterface->End();
+//	foliage->vertexdata->End();
+	currentFoliageLodFactor = newlod;
 }
 /*
@@ -170,8 +162,8 @@
 const IndexData* LodTreeLibrary::CurrentLOD_Trunk_Indices(void) const 
 { 
-	return trunk->dataRetrievalInterface;
-}
-
-
+	return trunk->GetIndexDataInterface();
+}
+
+/*
 const VertexData* LodTreeLibrary::Get_Foliage_VertexData(void) const
 {
@@ -181,9 +173,9 @@
 const IndexData* LodTreeLibrary::CurrentLOD_Foliage_Indices(void) const
 {
-	return foliage->indexdata;
-}
-
-
-/*void ThrowFileNotFoundError(const char *text)
+	return currentLOD_foliageIndexCount;
+}
+
+
+void ThrowFileNotFoundError(const char *text)
 {
 	throw Geometry::FileNotFound(text);
@@ -193,5 +185,6 @@
 {
 //	return current_foliage_indexcount;
-	return foliage->indexdata->GetNumValidIndices();
+//	return foliage->indexdata->GetNumValidIndices();
+	return foliage->active_leaf_count*6;
 }
 /*
@@ -213,5 +206,5 @@
 uint32 LodTreeLibrary::Get_Foliage_MaxIndexCount(void) const
 {
-	return foliage->indexdata->GetNumMaxIndices();
+	return foliage->leafTotal*6;
 }
 
